题目描述： 
  实时统计进程内存使用及检测内存泄漏  
  在linux平台上开发一个工具，此工具可以实时显示想要观察的进程的内存使用情况以及可能的内存泄漏问题，具体要求如下： 
  实时统计系统中各进程及其中包含的线程的内存使用情况；

  检测某个进程中的内存泄漏问题，包括：内存，文件句柄的泄漏情况，把检测情况实时显示或是输出到指定文件；
  

环境： Ubuntu 18.04  
内核版本： 5.4  
使用ebpf 需要安装bcc  https://github.com/iovisor/bcc  

可能会需要安装clang-11 llvm-11 python3  

追踪一段时间内的malloc,calloc,relloc和free函数的调用，检测一个用户进程的内存分配和释放  

使用ebpf在malloc，calloc，relloc，free函数添加uprobe，在用户进程执行到这些函数时，执行相应的程序，  
在内存分配函数时记录分配大小的字节数，并以分配首地址为键值，大小为内容添加到哈希表中。进程执行free函  
数时，对应的函数根据地址参数获得哈希表中内存大小，得到回收内存的  大小，并删除相应的哈希节点。最终将  
所有信息打印到out.stacks文件。可以使用一些工具将其生成火焰图，可以分析内存分配以及释放，并判断是否有  
内存泄漏。  

在执行count.py时，只能监测从count.py开始至结束时的内存分配回收情况，如果在进程在count.py未运行的其  
他时段分配回收内存，可能无法判断内存泄漏情况。  


可以使用以下命令打印malloc,calloc,relloc free函数的内存分配/回收字节数以及调用栈：  
#./count.py -p {pid}   
输入ctrl + c来停止追踪并将追踪内容打印输出  

可以使用以下命令生成火焰图：  
#./count.py -p {pid} > out.stacks  
#./stackcollapse.pl < out.stacks | ./flamegraph.pl --color=mem > out.svg  
来自 https://github.com/brendangregg/FlameGraph  

例如在test目录下运行test.c的代码,生成out.stack的文件如下，打印栈并打印分配、回收的字节数  
Hit Ctrl-C to end.  


  __GI___libc_free  
  a  
  fun  
  main  
  __libc_start_call_main  
  80  


  __GI___libc_malloc  
  a  
  fun  
  main  
  __libc_start_call_main  
  80  


  __GI___libc_free  
  b  
  fun   
  main  
  __libc_start_call_main  
  152  


  __GI___libc_malloc  
  b  
  fun  
  main  
  __libc_start_call_main  
  152  

生成对应火焰图如test目录out.svg  
